import { mergeProps, unref, defineComponent, computed, h, isRef, isReadonly } from 'vue';

function ownKeys(object, enumerableOnly) {
  var keys = Object.keys(object);

  if (Object.getOwnPropertySymbols) {
    var symbols = Object.getOwnPropertySymbols(object);
    enumerableOnly && (symbols = symbols.filter(function (sym) {
      return Object.getOwnPropertyDescriptor(object, sym).enumerable;
    })), keys.push.apply(keys, symbols);
  }

  return keys;
}

function _objectSpread2(target) {
  for (var i = 1; i < arguments.length; i++) {
    var source = null != arguments[i] ? arguments[i] : {};
    i % 2 ? ownKeys(Object(source), !0).forEach(function (key) {
      _defineProperty(target, key, source[key]);
    }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)) : ownKeys(Object(source)).forEach(function (key) {
      Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key));
    });
  }

  return target;
}

function _typeof(obj) {
  "@babel/helpers - typeof";

  return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (obj) {
    return typeof obj;
  } : function (obj) {
    return obj && "function" == typeof Symbol && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj;
  }, _typeof(obj);
}

function _defineProperty(obj, key, value) {
  if (key in obj) {
    Object.defineProperty(obj, key, {
      value: value,
      enumerable: true,
      configurable: true,
      writable: true
    });
  } else {
    obj[key] = value;
  }

  return obj;
}

function _slicedToArray(arr, i) {
  return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _unsupportedIterableToArray(arr, i) || _nonIterableRest();
}

function _toConsumableArray(arr) {
  return _arrayWithoutHoles(arr) || _iterableToArray(arr) || _unsupportedIterableToArray(arr) || _nonIterableSpread();
}

function _arrayWithoutHoles(arr) {
  if (Array.isArray(arr)) return _arrayLikeToArray(arr);
}

function _arrayWithHoles(arr) {
  if (Array.isArray(arr)) return arr;
}

function _iterableToArray(iter) {
  if (typeof Symbol !== "undefined" && iter[Symbol.iterator] != null || iter["@@iterator"] != null) return Array.from(iter);
}

function _iterableToArrayLimit(arr, i) {
  var _i = arr == null ? null : typeof Symbol !== "undefined" && arr[Symbol.iterator] || arr["@@iterator"];

  if (_i == null) return;
  var _arr = [];
  var _n = true;
  var _d = false;

  var _s, _e;

  try {
    for (_i = _i.call(arr); !(_n = (_s = _i.next()).done); _n = true) {
      _arr.push(_s.value);

      if (i && _arr.length === i) break;
    }
  } catch (err) {
    _d = true;
    _e = err;
  } finally {
    try {
      if (!_n && _i["return"] != null) _i["return"]();
    } finally {
      if (_d) throw _e;
    }
  }

  return _arr;
}

function _unsupportedIterableToArray(o, minLen) {
  if (!o) return;
  if (typeof o === "string") return _arrayLikeToArray(o, minLen);
  var n = Object.prototype.toString.call(o).slice(8, -1);
  if (n === "Object" && o.constructor) n = o.constructor.name;
  if (n === "Map" || n === "Set") return Array.from(o);
  if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen);
}

function _arrayLikeToArray(arr, len) {
  if (len == null || len > arr.length) len = arr.length;

  for (var i = 0, arr2 = new Array(len); i < len; i++) arr2[i] = arr[i];

  return arr2;
}

function _nonIterableSpread() {
  throw new TypeError("Invalid attempt to spread non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.");
}

function _nonIterableRest() {
  throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.");
}

var runtime = {exports: {}};

(function (module) {
  var runtime = function (exports) {

    var Op = Object.prototype;
    var hasOwn = Op.hasOwnProperty;
    var undefined$1; // More compressible than void 0.

    var $Symbol = typeof Symbol === "function" ? Symbol : {};
    var iteratorSymbol = $Symbol.iterator || "@@iterator";
    var asyncIteratorSymbol = $Symbol.asyncIterator || "@@asyncIterator";
    var toStringTagSymbol = $Symbol.toStringTag || "@@toStringTag";

    function define(obj, key, value) {
      Object.defineProperty(obj, key, {
        value: value,
        enumerable: true,
        configurable: true,
        writable: true
      });
      return obj[key];
    }

    try {
      // IE 8 has a broken Object.defineProperty that only works on DOM objects.
      define({}, "");
    } catch (err) {
      define = function define(obj, key, value) {
        return obj[key] = value;
      };
    }

    function wrap(innerFn, outerFn, self, tryLocsList) {
      // If outerFn provided and outerFn.prototype is a Generator, then outerFn.prototype instanceof Generator.
      var protoGenerator = outerFn && outerFn.prototype instanceof Generator ? outerFn : Generator;
      var generator = Object.create(protoGenerator.prototype);
      var context = new Context(tryLocsList || []); // The ._invoke method unifies the implementations of the .next,
      // .throw, and .return methods.

      generator._invoke = makeInvokeMethod(innerFn, self, context);
      return generator;
    }

    exports.wrap = wrap; // Try/catch helper to minimize deoptimizations. Returns a completion
    // record like context.tryEntries[i].completion. This interface could
    // have been (and was previously) designed to take a closure to be
    // invoked without arguments, but in all the cases we care about we
    // already have an existing method we want to call, so there's no need
    // to create a new function object. We can even get away with assuming
    // the method takes exactly one argument, since that happens to be true
    // in every case, so we don't have to touch the arguments object. The
    // only additional allocation required is the completion record, which
    // has a stable shape and so hopefully should be cheap to allocate.

    function tryCatch(fn, obj, arg) {
      try {
        return {
          type: "normal",
          arg: fn.call(obj, arg)
        };
      } catch (err) {
        return {
          type: "throw",
          arg: err
        };
      }
    }

    var GenStateSuspendedStart = "suspendedStart";
    var GenStateSuspendedYield = "suspendedYield";
    var GenStateExecuting = "executing";
    var GenStateCompleted = "completed"; // Returning this object from the innerFn has the same effect as
    // breaking out of the dispatch switch statement.

    var ContinueSentinel = {}; // Dummy constructor functions that we use as the .constructor and
    // .constructor.prototype properties for functions that return Generator
    // objects. For full spec compliance, you may wish to configure your
    // minifier not to mangle the names of these two functions.

    function Generator() {}

    function GeneratorFunction() {}

    function GeneratorFunctionPrototype() {} // This is a polyfill for %IteratorPrototype% for environments that
    // don't natively support it.


    var IteratorPrototype = {};
    define(IteratorPrototype, iteratorSymbol, function () {
      return this;
    });
    var getProto = Object.getPrototypeOf;
    var NativeIteratorPrototype = getProto && getProto(getProto(values([])));

    if (NativeIteratorPrototype && NativeIteratorPrototype !== Op && hasOwn.call(NativeIteratorPrototype, iteratorSymbol)) {
      // This environment has a native %IteratorPrototype%; use it instead
      // of the polyfill.
      IteratorPrototype = NativeIteratorPrototype;
    }

    var Gp = GeneratorFunctionPrototype.prototype = Generator.prototype = Object.create(IteratorPrototype);
    GeneratorFunction.prototype = GeneratorFunctionPrototype;
    define(Gp, "constructor", GeneratorFunctionPrototype);
    define(GeneratorFunctionPrototype, "constructor", GeneratorFunction);
    GeneratorFunction.displayName = define(GeneratorFunctionPrototype, toStringTagSymbol, "GeneratorFunction"); // Helper for defining the .next, .throw, and .return methods of the
    // Iterator interface in terms of a single ._invoke method.

    function defineIteratorMethods(prototype) {
      ["next", "throw", "return"].forEach(function (method) {
        define(prototype, method, function (arg) {
          return this._invoke(method, arg);
        });
      });
    }

    exports.isGeneratorFunction = function (genFun) {
      var ctor = typeof genFun === "function" && genFun.constructor;
      return ctor ? ctor === GeneratorFunction || // For the native GeneratorFunction constructor, the best we can
      // do is to check its .name property.
      (ctor.displayName || ctor.name) === "GeneratorFunction" : false;
    };

    exports.mark = function (genFun) {
      if (Object.setPrototypeOf) {
        Object.setPrototypeOf(genFun, GeneratorFunctionPrototype);
      } else {
        genFun.__proto__ = GeneratorFunctionPrototype;
        define(genFun, toStringTagSymbol, "GeneratorFunction");
      }

      genFun.prototype = Object.create(Gp);
      return genFun;
    }; // Within the body of any async function, `await x` is transformed to
    // `yield regeneratorRuntime.awrap(x)`, so that the runtime can test
    // `hasOwn.call(value, "__await")` to determine if the yielded value is
    // meant to be awaited.


    exports.awrap = function (arg) {
      return {
        __await: arg
      };
    };

    function AsyncIterator(generator, PromiseImpl) {
      function invoke(method, arg, resolve, reject) {
        var record = tryCatch(generator[method], generator, arg);

        if (record.type === "throw") {
          reject(record.arg);
        } else {
          var result = record.arg;
          var value = result.value;

          if (value && _typeof(value) === "object" && hasOwn.call(value, "__await")) {
            return PromiseImpl.resolve(value.__await).then(function (value) {
              invoke("next", value, resolve, reject);
            }, function (err) {
              invoke("throw", err, resolve, reject);
            });
          }

          return PromiseImpl.resolve(value).then(function (unwrapped) {
            // When a yielded Promise is resolved, its final value becomes
            // the .value of the Promise<{value,done}> result for the
            // current iteration.
            result.value = unwrapped;
            resolve(result);
          }, function (error) {
            // If a rejected Promise was yielded, throw the rejection back
            // into the async generator function so it can be handled there.
            return invoke("throw", error, resolve, reject);
          });
        }
      }

      var previousPromise;

      function enqueue(method, arg) {
        function callInvokeWithMethodAndArg() {
          return new PromiseImpl(function (resolve, reject) {
            invoke(method, arg, resolve, reject);
          });
        }

        return previousPromise = // If enqueue has been called before, then we want to wait until
        // all previous Promises have been resolved before calling invoke,
        // so that results are always delivered in the correct order. If
        // enqueue has not been called before, then it is important to
        // call invoke immediately, without waiting on a callback to fire,
        // so that the async generator function has the opportunity to do
        // any necessary setup in a predictable way. This predictability
        // is why the Promise constructor synchronously invokes its
        // executor callback, and why async functions synchronously
        // execute code before the first await. Since we implement simple
        // async functions in terms of async generators, it is especially
        // important to get this right, even though it requires care.
        previousPromise ? previousPromise.then(callInvokeWithMethodAndArg, // Avoid propagating failures to Promises returned by later
        // invocations of the iterator.
        callInvokeWithMethodAndArg) : callInvokeWithMethodAndArg();
      } // Define the unified helper method that is used to implement .next,
      // .throw, and .return (see defineIteratorMethods).


      this._invoke = enqueue;
    }

    defineIteratorMethods(AsyncIterator.prototype);
    define(AsyncIterator.prototype, asyncIteratorSymbol, function () {
      return this;
    });
    exports.AsyncIterator = AsyncIterator; // Note that simple async functions are implemented on top of
    // AsyncIterator objects; they just return a Promise for the value of
    // the final result produced by the iterator.

    exports.async = function (innerFn, outerFn, self, tryLocsList, PromiseImpl) {
      if (PromiseImpl === void 0) PromiseImpl = Promise;
      var iter = new AsyncIterator(wrap(innerFn, outerFn, self, tryLocsList), PromiseImpl);
      return exports.isGeneratorFunction(outerFn) ? iter // If outerFn is a generator, return the full iterator.
      : iter.next().then(function (result) {
        return result.done ? result.value : iter.next();
      });
    };

    function makeInvokeMethod(innerFn, self, context) {
      var state = GenStateSuspendedStart;
      return function invoke(method, arg) {
        if (state === GenStateExecuting) {
          throw new Error("Generator is already running");
        }

        if (state === GenStateCompleted) {
          if (method === "throw") {
            throw arg;
          } // Be forgiving, per 25.3.3.3.3 of the spec:
          // https://people.mozilla.org/~jorendorff/es6-draft.html#sec-generatorresume


          return doneResult();
        }

        context.method = method;
        context.arg = arg;

        while (true) {
          var delegate = context.delegate;

          if (delegate) {
            var delegateResult = maybeInvokeDelegate(delegate, context);

            if (delegateResult) {
              if (delegateResult === ContinueSentinel) continue;
              return delegateResult;
            }
          }

          if (context.method === "next") {
            // Setting context._sent for legacy support of Babel's
            // function.sent implementation.
            context.sent = context._sent = context.arg;
          } else if (context.method === "throw") {
            if (state === GenStateSuspendedStart) {
              state = GenStateCompleted;
              throw context.arg;
            }

            context.dispatchException(context.arg);
          } else if (context.method === "return") {
            context.abrupt("return", context.arg);
          }

          state = GenStateExecuting;
          var record = tryCatch(innerFn, self, context);

          if (record.type === "normal") {
            // If an exception is thrown from innerFn, we leave state ===
            // GenStateExecuting and loop back for another invocation.
            state = context.done ? GenStateCompleted : GenStateSuspendedYield;

            if (record.arg === ContinueSentinel) {
              continue;
            }

            return {
              value: record.arg,
              done: context.done
            };
          } else if (record.type === "throw") {
            state = GenStateCompleted; // Dispatch the exception by looping back around to the
            // context.dispatchException(context.arg) call above.

            context.method = "throw";
            context.arg = record.arg;
          }
        }
      };
    } // Call delegate.iterator[context.method](context.arg) and handle the
    // result, either by returning a { value, done } result from the
    // delegate iterator, or by modifying context.method and context.arg,
    // setting context.delegate to null, and returning the ContinueSentinel.


    function maybeInvokeDelegate(delegate, context) {
      var method = delegate.iterator[context.method];

      if (method === undefined$1) {
        // A .throw or .return when the delegate iterator has no .throw
        // method always terminates the yield* loop.
        context.delegate = null;

        if (context.method === "throw") {
          // Note: ["return"] must be used for ES3 parsing compatibility.
          if (delegate.iterator["return"]) {
            // If the delegate iterator has a return method, give it a
            // chance to clean up.
            context.method = "return";
            context.arg = undefined$1;
            maybeInvokeDelegate(delegate, context);

            if (context.method === "throw") {
              // If maybeInvokeDelegate(context) changed context.method from
              // "return" to "throw", let that override the TypeError below.
              return ContinueSentinel;
            }
          }

          context.method = "throw";
          context.arg = new TypeError("The iterator does not provide a 'throw' method");
        }

        return ContinueSentinel;
      }

      var record = tryCatch(method, delegate.iterator, context.arg);

      if (record.type === "throw") {
        context.method = "throw";
        context.arg = record.arg;
        context.delegate = null;
        return ContinueSentinel;
      }

      var info = record.arg;

      if (!info) {
        context.method = "throw";
        context.arg = new TypeError("iterator result is not an object");
        context.delegate = null;
        return ContinueSentinel;
      }

      if (info.done) {
        // Assign the result of the finished delegate to the temporary
        // variable specified by delegate.resultName (see delegateYield).
        context[delegate.resultName] = info.value; // Resume execution at the desired location (see delegateYield).

        context.next = delegate.nextLoc; // If context.method was "throw" but the delegate handled the
        // exception, let the outer generator proceed normally. If
        // context.method was "next", forget context.arg since it has been
        // "consumed" by the delegate iterator. If context.method was
        // "return", allow the original .return call to continue in the
        // outer generator.

        if (context.method !== "return") {
          context.method = "next";
          context.arg = undefined$1;
        }
      } else {
        // Re-yield the result returned by the delegate method.
        return info;
      } // The delegate iterator is finished, so forget it and continue with
      // the outer generator.


      context.delegate = null;
      return ContinueSentinel;
    } // Define Generator.prototype.{next,throw,return} in terms of the
    // unified ._invoke helper method.


    defineIteratorMethods(Gp);
    define(Gp, toStringTagSymbol, "Generator"); // A Generator should always return itself as the iterator object when the
    // @@iterator function is called on it. Some browsers' implementations of the
    // iterator prototype chain incorrectly implement this, causing the Generator
    // object to not be returned from this call. This ensures that doesn't happen.
    // See https://github.com/facebook/regenerator/issues/274 for more details.

    define(Gp, iteratorSymbol, function () {
      return this;
    });
    define(Gp, "toString", function () {
      return "[object Generator]";
    });

    function pushTryEntry(locs) {
      var entry = {
        tryLoc: locs[0]
      };

      if (1 in locs) {
        entry.catchLoc = locs[1];
      }

      if (2 in locs) {
        entry.finallyLoc = locs[2];
        entry.afterLoc = locs[3];
      }

      this.tryEntries.push(entry);
    }

    function resetTryEntry(entry) {
      var record = entry.completion || {};
      record.type = "normal";
      delete record.arg;
      entry.completion = record;
    }

    function Context(tryLocsList) {
      // The root entry object (effectively a try statement without a catch
      // or a finally block) gives us a place to store values thrown from
      // locations where there is no enclosing try statement.
      this.tryEntries = [{
        tryLoc: "root"
      }];
      tryLocsList.forEach(pushTryEntry, this);
      this.reset(true);
    }

    exports.keys = function (object) {
      var keys = [];

      for (var key in object) {
        keys.push(key);
      }

      keys.reverse(); // Rather than returning an object with a next method, we keep
      // things simple and return the next function itself.

      return function next() {
        while (keys.length) {
          var key = keys.pop();

          if (key in object) {
            next.value = key;
            next.done = false;
            return next;
          }
        } // To avoid creating an additional object, we just hang the .value
        // and .done properties off the next function object itself. This
        // also ensures that the minifier will not anonymize the function.


        next.done = true;
        return next;
      };
    };

    function values(iterable) {
      if (iterable) {
        var iteratorMethod = iterable[iteratorSymbol];

        if (iteratorMethod) {
          return iteratorMethod.call(iterable);
        }

        if (typeof iterable.next === "function") {
          return iterable;
        }

        if (!isNaN(iterable.length)) {
          var i = -1,
              next = function next() {
            while (++i < iterable.length) {
              if (hasOwn.call(iterable, i)) {
                next.value = iterable[i];
                next.done = false;
                return next;
              }
            }

            next.value = undefined$1;
            next.done = true;
            return next;
          };

          return next.next = next;
        }
      } // Return an iterator with no values.


      return {
        next: doneResult
      };
    }

    exports.values = values;

    function doneResult() {
      return {
        value: undefined$1,
        done: true
      };
    }

    Context.prototype = {
      constructor: Context,
      reset: function reset(skipTempReset) {
        this.prev = 0;
        this.next = 0; // Resetting context._sent for legacy support of Babel's
        // function.sent implementation.

        this.sent = this._sent = undefined$1;
        this.done = false;
        this.delegate = null;
        this.method = "next";
        this.arg = undefined$1;
        this.tryEntries.forEach(resetTryEntry);

        if (!skipTempReset) {
          for (var name in this) {
            // Not sure about the optimal order of these conditions:
            if (name.charAt(0) === "t" && hasOwn.call(this, name) && !isNaN(+name.slice(1))) {
              this[name] = undefined$1;
            }
          }
        }
      },
      stop: function stop() {
        this.done = true;
        var rootEntry = this.tryEntries[0];
        var rootRecord = rootEntry.completion;

        if (rootRecord.type === "throw") {
          throw rootRecord.arg;
        }

        return this.rval;
      },
      dispatchException: function dispatchException(exception) {
        if (this.done) {
          throw exception;
        }

        var context = this;

        function handle(loc, caught) {
          record.type = "throw";
          record.arg = exception;
          context.next = loc;

          if (caught) {
            // If the dispatched exception was caught by a catch block,
            // then let that catch block handle the exception normally.
            context.method = "next";
            context.arg = undefined$1;
          }

          return !!caught;
        }

        for (var i = this.tryEntries.length - 1; i >= 0; --i) {
          var entry = this.tryEntries[i];
          var record = entry.completion;

          if (entry.tryLoc === "root") {
            // Exception thrown outside of any try block that could handle
            // it, so set the completion value of the entire function to
            // throw the exception.
            return handle("end");
          }

          if (entry.tryLoc <= this.prev) {
            var hasCatch = hasOwn.call(entry, "catchLoc");
            var hasFinally = hasOwn.call(entry, "finallyLoc");

            if (hasCatch && hasFinally) {
              if (this.prev < entry.catchLoc) {
                return handle(entry.catchLoc, true);
              } else if (this.prev < entry.finallyLoc) {
                return handle(entry.finallyLoc);
              }
            } else if (hasCatch) {
              if (this.prev < entry.catchLoc) {
                return handle(entry.catchLoc, true);
              }
            } else if (hasFinally) {
              if (this.prev < entry.finallyLoc) {
                return handle(entry.finallyLoc);
              }
            } else {
              throw new Error("try statement without catch or finally");
            }
          }
        }
      },
      abrupt: function abrupt(type, arg) {
        for (var i = this.tryEntries.length - 1; i >= 0; --i) {
          var entry = this.tryEntries[i];

          if (entry.tryLoc <= this.prev && hasOwn.call(entry, "finallyLoc") && this.prev < entry.finallyLoc) {
            var finallyEntry = entry;
            break;
          }
        }

        if (finallyEntry && (type === "break" || type === "continue") && finallyEntry.tryLoc <= arg && arg <= finallyEntry.finallyLoc) {
          // Ignore the finally entry if control is not jumping to a
          // location outside the try/catch block.
          finallyEntry = null;
        }

        var record = finallyEntry ? finallyEntry.completion : {};
        record.type = type;
        record.arg = arg;

        if (finallyEntry) {
          this.method = "next";
          this.next = finallyEntry.finallyLoc;
          return ContinueSentinel;
        }

        return this.complete(record);
      },
      complete: function complete(record, afterLoc) {
        if (record.type === "throw") {
          throw record.arg;
        }

        if (record.type === "break" || record.type === "continue") {
          this.next = record.arg;
        } else if (record.type === "return") {
          this.rval = this.arg = record.arg;
          this.method = "return";
          this.next = "end";
        } else if (record.type === "normal" && afterLoc) {
          this.next = afterLoc;
        }

        return ContinueSentinel;
      },
      finish: function finish(finallyLoc) {
        for (var i = this.tryEntries.length - 1; i >= 0; --i) {
          var entry = this.tryEntries[i];

          if (entry.finallyLoc === finallyLoc) {
            this.complete(entry.completion, entry.afterLoc);
            resetTryEntry(entry);
            return ContinueSentinel;
          }
        }
      },
      "catch": function _catch(tryLoc) {
        for (var i = this.tryEntries.length - 1; i >= 0; --i) {
          var entry = this.tryEntries[i];

          if (entry.tryLoc === tryLoc) {
            var record = entry.completion;

            if (record.type === "throw") {
              var thrown = record.arg;
              resetTryEntry(entry);
            }

            return thrown;
          }
        } // The context.catch method must only be called with a location
        // argument that corresponds to a known catch block.


        throw new Error("illegal catch attempt");
      },
      delegateYield: function delegateYield(iterable, resultName, nextLoc) {
        this.delegate = {
          iterator: values(iterable),
          resultName: resultName,
          nextLoc: nextLoc
        };

        if (this.method === "next") {
          // Deliberately forget the last sent value so that we don't
          // accidentally pass it on to the delegate.
          this.arg = undefined$1;
        }

        return ContinueSentinel;
      }
    }; // Regardless of whether this script is executing as a CommonJS module
    // or not, return the runtime object so that we can declare the variable
    // regeneratorRuntime in the outer scope, which allows this module to be
    // injected easily by `bin/regenerator --include-runtime script.js`.

    return exports;
  }( // If this script is executing as a CommonJS module, use module.exports
  // as the regeneratorRuntime namespace. Otherwise create a new empty
  // object. Either way, the resulting object will be used to initialize
  // the regeneratorRuntime variable at the top of this file.
  module.exports );

  try {
    regeneratorRuntime = runtime;
  } catch (accidentalStrictMode) {
    // This module should not be running in strict mode, so the above
    // assignment should always work unless something is misconfigured. Just
    // in case runtime.js accidentally runs in strict mode, in modern engines
    // we can explicitly access globalThis. In older engines we can escape
    // strict mode using a global Function call. This could conceivably fail
    // if a Content Security Policy forbids using Function, but in that case
    // the proper solution is to fix the accidental strict mode problem. If
    // you've misconfigured your bundler to force strict mode and applied a
    // CSP to forbid Function, and you're not willing to fix either of those
    // problems, please detail your unique predicament in a GitHub issue.
    if ((typeof globalThis === "undefined" ? "undefined" : _typeof(globalThis)) === "object") {
      globalThis.regeneratorRuntime = runtime;
    } else {
      Function("r", "regeneratorRuntime = r")(runtime);
    }
  }
})(runtime);

/*
 * Copyright (c) 2022.
 * Author Peter Placzek (tada5hi)
 * For the full copyright and license information,
 * view the LICENSE file that was distributed with this source code.
 */
var Component;

(function (Component) {
  Component["Pagination"] = "pagination";
  Component["FormBase"] = "formBase";
  Component["FormGroup"] = "formGroup";
  Component["FormInput"] = "formInput";
  Component["FormSelect"] = "formSelect";
  Component["FormSubmit"] = "formSubmit";
  Component["FormTextarea"] = "formTextarea";
  Component["ItemActionToggle"] = "itemActionToggle";
  Component["ListBase"] = "listBase";
  Component["ListActionRefresh"] = "listActionRefresh";
  Component["ListHeader"] = "listHeader";
  Component["ListItem"] = "listItem";
  Component["ListItems"] = "listItems";
  Component["ListNoMore"] = "listNoMore";
  Component["ListPagination"] = "listPagination";
  Component["ListSearch"] = "listSearch";
  Component["ListTitle"] = "listTitle";
})(Component || (Component = {}));

/*
 * Copyright (c) 2022.
 * Author Peter Placzek (tada5hi)
 * For the full copyright and license information,
 * view the LICENSE file that was distributed with this source code.
 */
function isVNodeClassOption(name) {
  return name.toLowerCase().indexOf('class') !== -1;
}
function isVNodeStyleOption(name) {
  return name.toLowerCase().indexOf('style') !== -1;
}
function isVNodeListenerOption(name) {
  return name.startsWith('on');
}
function isVNodePropsOption(name) {
  return name.toLowerCase().indexOf('props') !== -1;
}
function isVNodeOption(name) {
  return isVNodeClassOption(name) || isVNodeStyleOption(name) || isVNodeListenerOption(name) || isVNodePropsOption(name);
}

function isObject(item) {
  return item && _typeof(item) === 'object' && !Array.isArray(item);
}

function mergeVNodeOption(key, target, source) {
  if (typeof target === 'undefined') {
    return source;
  }

  if (typeof source === 'undefined') {
    return target;
  }

  if (isVNodeClassOption(key)) {
    var _mergeProps = mergeProps({
      class: target
    }, {
      class: source
    }),
        clazz = _mergeProps.class;

    return clazz;
  }

  if (isVNodeStyleOption(key)) {
    var _mergeProps2 = mergeProps({
      style: target
    }, {
      style: source
    }),
        style = _mergeProps2.style;

    return style;
  }

  if (isVNodeListenerOption(key)) {
    var _mergeProps3 = mergeProps(_defineProperty({}, key, target), _defineProperty({}, key, source)),
        listener = _mergeProps3[key];

    return listener;
  }

  if (isVNodePropsOption(key)) {
    return mergeProps(target, source);
  }

  return target !== null && target !== void 0 ? target : source;
}
function mergeOption(key, target, source) {
  if (isVNodeOption(key)) {
    return mergeVNodeOption(key, target, source);
  }

  if (isObject(key) && isObject(source)) {
    return _objectSpread2(_objectSpread2({}, source), target);
  }

  return target !== null && target !== void 0 ? target : source;
}
function mergeOptions(target) {
  for (var _len = arguments.length, sources = new Array(_len > 1 ? _len - 1 : 0), _key = 1; _key < _len; _key++) {
    sources[_key - 1] = arguments[_key];
  }

  if (!sources.length) return target;
  var source = sources.shift();

  if (isObject(target) && isObject(source)) {
    var keys = Object.keys(source);

    for (var i = 0; i < keys.length; i++) {
      if (isObject(source[keys[i]])) {
        if (!target[keys[i]]) Object.assign(target, _defineProperty({}, keys[i], {}));
        mergeOptions(target[keys[i]], source[keys[i]]);
      } else if (isVNodeOption(keys[i])) {
        target[keys[i]] = mergeVNodeOption(keys[i], target[keys[i]], source[keys[i]]);
      } else if (!target[keys[i]]) {
        Object.assign(target, _defineProperty({}, keys[i], source[keys[i]]));
      }
    }
  }

  return mergeOptions.apply(void 0, [target].concat(sources));
}

/*
 * Copyright (c) 2022.
 * Author Peter Placzek (tada5hi)
 * For the full copyright and license information,
 * view the LICENSE file that was distributed with this source code.
 */
var instance;
function setConfig(input) {
  instance = extendConfig(input);
  return instance;
}
function useConfig() {
  if (typeof instance !== 'undefined') {
    return instance;
  }

  instance = extendConfig({});
  return instance;
}
function extendConfig(input) {
  return {
    library: input.library || {},
    component: input.component || {}
  };
}

/*
 * Copyright (c) 2021.
 * Author Peter Placzek (tada5hi)
 * For the full copyright and license information,
 * view the LICENSE file that was distributed with this source code.
 */
// eslint-disable-next-line @typescript-eslint/ban-types
function hasOwnProperty(obj, prop) {
  return Object.prototype.hasOwnProperty.call(obj, prop);
}

/*
 * Copyright (c) 2022.
 * Author Peter Placzek (tada5hi)
 * For the full copyright and license information,
 * view the LICENSE file that was distributed with this source code.
 */
function isPromise(p) {
  return _typeof(p) === 'object' && p !== null && (p instanceof Promise || // eslint-disable-next-line @typescript-eslint/ban-ts-comment
  // @ts-ignore
  typeof p.then === 'function');
}

/*
 * Copyright (c) 2022.
 * Author Peter Placzek (tada5hi)
 * For the full copyright and license information,
 * view the LICENSE file that was distributed with this source code.
 */
function unrefWithDefault(value, alt) {
  var raw = unref(value);

  if (typeof raw === 'undefined') {
    return alt;
  }

  return raw;
}
function unrefWithOptionalDefault(value, alt) {
  var raw = unref(value);

  if (typeof raw === 'undefined') {
    return alt;
  }

  return raw;
}

/*
 * Copyright (c) 2022.
 * Author Peter Placzek (tada5hi)
 * For the full copyright and license information,
 * view the LICENSE file that was distributed with this source code.
 */
function getConfigComponentOption(component, key) {
  var config = useConfig();

  if (!config.component) {
    return undefined;
  }

  if (config.component[component]) {
    return config.component[component][key];
  }

  return undefined;
}
function hasConfigComponentOption(component, key) {
  var config = useConfig();
  return config.component && config.component[component] && hasOwnProperty(config.component[component], key);
}
function getConfigLibraryComponentOption(library, component, key) {
  var config = useConfig();

  if (!config.library) {
    return undefined;
  }

  if (config.library[library] && typeof config.library[library].options !== 'undefined' && config.library[library].options[component]) {
    return config.library[library].options[component][key];
  }

  return undefined;
}
function hasConfigLibraryComponentOption(library, component, key) {
  var config = useConfig();
  return config.library && config.library[library] && config.library[library].options && config.library[library].options[component] && hasOwnProperty(config.library[library].options[component], key);
}

function extendOptionValueWithLibraries(component, key, value, libraries) {
  var config = useConfig();

  var keys = _toConsumableArray(new Set([].concat(_toConsumableArray(Object.keys(config.library)), _toConsumableArray(Object.keys(libraries)))));

  for (var i = 0; i < keys.length; i++) {
    var isEnabled = hasOwnProperty(config.library, keys[i]) && Boolean(config.library[keys[i]].enabled) || hasOwnProperty(libraries, keys[i]) && Boolean(libraries[keys[i]].enabled);

    if (!isEnabled) {
      continue;
    }

    if (hasOwnProperty(config.library, keys[i]) && hasConfigLibraryComponentOption(keys[i], component, key)) {
      value = mergeOption(key, value, getConfigLibraryComponentOption(keys[i], component, key));
    } else if (hasOwnProperty(libraries, keys[i]) && typeof libraries[keys[i]].value !== 'undefined') {
      value = mergeOption(key, value, libraries[keys[i]].value);
    }
  }

  return value;
}
function buildOptionValue(context) {
  var target = context.value;

  if (hasConfigComponentOption(context.component, context.key)) {
    if (typeof target !== 'undefined') {
      target = mergeVNodeOption(context.key, target, getConfigComponentOption(context.component, context.key));
    } else {
      target = getConfigComponentOption(context.component, context.key);
    }
  }

  if (typeof target === 'undefined') {
    target = context.alt;
  }

  if (typeof target !== 'undefined') {
    // todo: if alt value override with library one if available :)
    target = extendOptionValueWithLibraries(context.component, context.key, target, context.library || {});
  }

  return target;
}
function buildOptionValueOrFail(context) {
  var target = buildOptionValue(context);

  if (typeof target === 'undefined') {
    throw new Error("A value for option ".concat(context.key, " of component ").concat(context.component, " is required."));
  }

  return target;
}

/*
 * Copyright (c) 2022.
 * Author Peter Placzek (tada5hi)
 * For the full copyright and license information,
 * view the LICENSE file that was distributed with this source code.
 */
var Library;

(function (Library) {
  Library["BOOTSTRAP"] = "bootstrap";
  Library["FONT_AWESOME"] = "fontAwesome";
})(Library || (Library = {}));

var FormGroup = defineComponent({
  props: {
    validations: {
      default: function _default() {},
      type: Object
    },
    validationMessages: {
      type: Object,
      default: undefined
    },
    validationTranslator: {
      type: Function,
      default: undefined
    }
  },
  setup: function setup(props, _ref) {
    var slots = _ref.slots;

    var translate = function translate(validator, properties) {
      if (props.validationMessages && Object.prototype.hasOwnProperty.call(props.validationMessages, validator)) {
        return props.validationMessages[validator];
      }

      if (typeof props.validationTranslator !== 'undefined') {
        var translation = props.validationTranslator(validator, properties || {});

        if (typeof translation === 'string') {
          return translation;
        }
      }

      return "The ".concat(validator, " operator condition is not fulfilled.");
    };

    var invalid = computed(function () {
      return props.validations && props.validations.$dirty && props.validations.$invalid;
    });
    var errors = computed(function () {
      if (!invalid.value || typeof props.validations === 'undefined') {
        return [];
      }

      return Object.keys(props.validations.$params).reduce(function (errors, validator) {
        if (props.validations && !props.validations[validator]) {
          errors.push(translate(validator, props.validations.$params[validator]));
        }

        return errors;
      }, []);
    });
    var errorClazz = buildOptionValue({
      component: Component.FormGroup,
      key: 'errorClass',
      alt: [],
      library: _defineProperty({}, Library.BOOTSTRAP, {
        value: 'form-group-error'
      })
    });
    var warningClazz = buildOptionValue({
      component: Component.FormGroup,
      key: 'warningClass',
      alt: [],
      library: _defineProperty({}, Library.BOOTSTRAP, {
        value: 'form-group-warning'
      })
    });
    return function () {
      return h('div', _objectSpread2({
        class: [buildOptionValue({
          component: Component.FormGroup,
          key: 'class',
          alt: [],
          library: _defineProperty({}, Library.BOOTSTRAP, {
            value: 'form-group'
          })
        })].concat(_toConsumableArray(props.validations.$error ? [errorClazz] : []), _toConsumableArray(props.validations.$invalid && !props.validations.$dirty ? [warningClazz] : []))
      }, buildOptionValue({
        component: Component.FormGroup,
        key: 'props',
        alt: {}
      })), [slots.default ? slots.default({
        errors: errors.value,
        invalid: invalid.value
      }) : h(''), errors.value.map(function (error) {
        return h('div', {
          class: 'form-group-hint group-required'
        }, [error]);
      })]);
    };
  }
});

/*
 * Copyright (c) 2022.
 * Author Peter Placzek (tada5hi)
 * For the full copyright and license information,
 * view the LICENSE file that was distributed with this source code.
 */

var components = /*#__PURE__*/Object.freeze({
  __proto__: null,
  FormGroup: FormGroup
});

/*
 * Copyright (c) 2022.
 * Author Peter Placzek (tada5hi)
 * For the full copyright and license information,
 * view the LICENSE file that was distributed with this source code.
 */
function setMaybeRefValue(input, value) {
  if (isRef(input)) {
    if (!isReadonly(input)) {
      input.value = value;
    }
  } else {
    input = value;
  }

  return input;
}
function pushMaybeRefArrayValue(input, value) {
  if (isRef(input)) {
    input.value.push(value);
  } else {
    input.push(value);
  }

  return value;
}
function spliceMaybeRefArray(input, index, amount) {
  if (isRef(input)) {
    input.value.splice(index, amount);
  } else {
    input.splice(index, amount);
  }

  return input;
}

function buildFormBaseOptions(options, component, defaults) {
  defaults = defaults || {};
  return _objectSpread2(_objectSpread2({}, options), {}, {
    class: buildOptionValueOrFail(_objectSpread2({
      component: component,
      key: 'class',
      value: unref(options.class),
      alt: 'form-control',
      library: _defineProperty({}, Library.BOOTSTRAP, {})
    }, defaults.class)),
    props: buildOptionValueOrFail(_objectSpread2({
      component: component,
      key: 'props',
      value: unref(options.props),
      alt: {}
    }, defaults.props)),
    label: buildOptionValueOrFail(_objectSpread2({
      component: component,
      key: 'label',
      value: unref(options.label),
      alt: true
    }, defaults.label)),
    labelContent: buildOptionValueOrFail(_objectSpread2({
      component: component,
      key: 'labelContent',
      value: unref(options.labelContent),
      alt: 'Input'
    }, defaults.labelContent)),
    validationMessages: unrefWithDefault(options.validationMessages, {}),
    validationRulesResult: unrefWithDefault(options.validationRulesResult, {})
  });
}
function handleFormValueChanged(options, value) {
  if (typeof options.value !== 'undefined') {
    setMaybeRefValue(options.value, value);
  }

  if (typeof options.validationRulesResult.$model !== 'undefined') {
    setMaybeRefValue(options.validationRulesResult.$model, value);
  }

  if (options.change) {
    options.change.call(null, value);
  }

  return options;
}

function buildListBaseOptions(options, component, defaults) {
  defaults = defaults || {};
  return _objectSpread2(_objectSpread2({}, options), {}, {
    type: buildOptionValueOrFail(_objectSpread2({
      component: component,
      key: 'type',
      value: unref(options.type),
      alt: 'div'
    }, defaults.type)),
    slotItems: options.slotItems || {},
    slotProps: buildOptionValueOrFail(_objectSpread2({
      component: component,
      key: 'slotProps',
      value: unref(options.slotProps),
      alt: {}
    }, defaults.slotProps)),
    class: buildOptionValueOrFail(_objectSpread2({
      component: component,
      key: 'class',
      value: unref(options.class),
      alt: []
    }, defaults.class)),
    props: buildOptionValueOrFail(_objectSpread2({
      component: component,
      key: 'props',
      value: unref(options.props),
      alt: {}
    }, defaults.props))
  });
}

/*
 * Copyright (c) 2022.
 * Author Peter Placzek (tada5hi)
 * For the full copyright and license information,
 * view the LICENSE file that was distributed with this source code.
 */
/**
 * Returns true if either scoped or unscoped named slot exists
 *
 * @returns {Array|undefined} VNodes
 *
 * @param names
 * @param $slots
 */

function hasNormalizedSlot(names) {
  var $slots = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {};
  names = Array.isArray(names) ? names : [names]; // Ensure names is an array

  names = names.filter(function (name) {
    return name;
  }); // Returns true if the either a $scopedSlot or $slot exists with the specified name

  return names.some(function (name) {
    return hasOwnProperty($slots, name);
  });
}
/**
 * Returns VNodes for named slot either scoped or unscoped
 *
 * @param names
 * @param {String} scope
 * @param $slots
 *
 * @returns {Array} VNodes
 */

function normalizeSlot(names) {
  var scope = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {};
  var $slots = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : {};
  // Ensure names is an array
  names = Array.isArray(names) ? names : [names]; // Ensure names is an array

  names = names.filter(function (name) {
    return name;
  });

  var slot = function slot() {
    return [];
  };

  for (var i = 0; i < names.length && !slot; i++) {
    var name = names[i];
    slot = $slots[name];
  }

  return slot(scope);
}

/*
 * Copyright (c) 2022.
 * Author Peter Placzek (tada5hi)
 * For the full copyright and license information,
 * view the LICENSE file that was distributed with this source code.
 */
function initPropertiesFromSource(source, destination) {
  if (_typeof(source) !== 'object') {
    return;
  }

  var keys = Object.keys(destination);

  for (var i = 0; i < keys.length; i++) {
    if (Object.prototype.hasOwnProperty.call(source, keys[i])) {
      var key = keys[i];
      destination[key] = source[keys[i]];
    }
  }
}

function buildFormInputOptions(input) {
  var options = buildFormBaseOptions(input, Component.FormInput);
  return _objectSpread2(_objectSpread2({}, options), {}, {
    groupClass: buildOptionValueOrFail({
      component: Component.FormInput,
      key: 'groupClass',
      value: unref(options.groupClass),
      alt: '',
      library: _defineProperty({}, Library.BOOTSTRAP, {
        value: 'input-group'
      })
    }),
    groupAppend: buildOptionValueOrFail({
      component: Component.FormInput,
      key: 'groupAppend',
      value: unref(options.groupAppend),
      alt: false
    }),
    groupAppendClass: buildOptionValueOrFail({
      component: Component.FormInput,
      key: 'groupAppendClass',
      value: unref(options.groupAppendClass),
      alt: '',
      library: _defineProperty({}, Library.BOOTSTRAP, {
        value: 'input-group-append'
      })
    }),
    groupAppendTextClass: buildOptionValueOrFail({
      component: Component.FormInput,
      key: 'groupAppendTextClass',
      value: unref(options.groupAppendTextClass),
      alt: '',
      library: _defineProperty({}, Library.BOOTSTRAP, {
        value: 'input-group-text'
      })
    }),
    groupAppendTextContent: buildOptionValueOrFail({
      component: Component.FormInput,
      key: 'groupAppendTextContent',
      value: unref(options.groupAppendTextContent),
      alt: ''
    }),
    groupPrepend: buildOptionValueOrFail({
      component: Component.FormInput,
      key: 'groupPrepend',
      value: unref(options.groupPrepend),
      alt: false
    }),
    groupPrependClass: buildOptionValueOrFail({
      component: Component.FormInput,
      key: 'groupPrependClass',
      value: unref(options.groupPrependClass),
      alt: '',
      library: _defineProperty({}, Library.BOOTSTRAP, {
        value: 'input-group-prepend'
      })
    }),
    groupPrependTextClass: buildOptionValueOrFail({
      component: Component.FormInput,
      key: 'groupPrependTextClass',
      value: unref(options.groupPrependTextClass),
      alt: '',
      library: _defineProperty({}, Library.BOOTSTRAP, {
        value: 'input-group-text'
      })
    }),
    groupPrependTextContent: buildOptionValueOrFail({
      component: Component.FormInput,
      key: 'groupPrependTextContent',
      value: unref(options.groupPrependTextContent),
      alt: ''
    })
  });
}
function buildFormInput(input) {
  var options = buildFormInputOptions(input);
  var children = [];

  if (options.label) {
    children.push(h('label', [options.labelContent]));
  }

  var inputGroupChildren = [];

  if (options.groupPrepend) {
    inputGroupChildren.push(h('div', {
      class: options.groupPrependClass
    }, [h('div', {
      class: options.groupPrependTextClass
    }, [options.groupPrependTextContent])]));
  }

  var rawValue = unref(options.value);
  var rawValidationValue = unref(options.validationRulesResult.$model);
  inputGroupChildren.push(h('input', mergeProps(_objectSpread2(_objectSpread2({
    type: 'text',
    placeholder: '...',
    class: options.class,
    onInput: function onInput($event) {
      if ($event.target.composing) {
        return;
      }

      handleFormValueChanged(options, $event.target.value);
    }
  }, typeof rawValue !== 'undefined' ? {
    value: rawValue
  } : {}), typeof rawValidationValue !== 'undefined' ? {
    value: rawValidationValue
  } : {}), options.props)));

  if (options.groupAppend) {
    inputGroupChildren.push(h('div', {
      class: options.groupAppendClass
    }, [h('div', {
      class: options.groupAppendTextClass
    }, [options.groupAppendTextContent])]));
  }

  children.push(h('div', {
    class: options.groupClass
  }, inputGroupChildren));
  return h(FormGroup, {
    validations: options.validationRulesResult,
    validationMessages: options.validationMessages,
    validationTranslator: options.validationTranslator
  }, {
    default: function _default() {
      return children;
    }
  });
}

function buildFormSelectOptions(input) {
  var options = buildFormBaseOptions(input, Component.FormSelect);
  return _objectSpread2(_objectSpread2({}, options), {}, {
    options: unref(options.options),
    optionDefaultText: buildOptionValueOrFail({
      component: Component.FormSelect,
      key: 'optionDefaultText',
      value: unref(options.optionDefaultText),
      alt: 'Select'
    })
  });
}
function buildFormSelect(input) {
  var options = buildFormSelectOptions(input);
  var children = [];

  if (options.label) {
    children.push(h('label', [options.labelContent]));
  }

  var rawValue = unref(options.value);
  var rawValidationValue = unref(options.validationRulesResult.$model);
  return h(FormGroup, {
    validations: options.validationRulesResult,
    validationMessages: options.validationMessages,
    validationTranslator: options.validationTranslator
  }, {
    default: function _default() {
      return [].concat(children, [h('select', mergeProps(_objectSpread2(_objectSpread2({
        class: options.class,
        onChange: function onChange($event) {
          var $$selectedVal = Array.prototype.filter.call($event.target.options, function (o) {
            return o.selected;
          }).map(function (o) {
            return '_value' in o ? o._value : o.value;
          });
          var value = $event.target.multiple ? $$selectedVal : $$selectedVal[0];
          handleFormValueChanged(options, value);
        }
      }, typeof rawValue !== 'undefined' ? {
        value: rawValue
      } : {}), typeof rawValidationValue !== 'undefined' ? {
        value: rawValidationValue
      } : {}), options.props), [h('option', {
        value: ''
      }, ['-- ', options.optionDefaultText, ' --']), options.options.map(function (item) {
        return h('option', {
          key: item.id,
          value: item.id
        }, item.value);
      })])]);
    }
  });
}

function buildFormSubmitOptions(options) {
  var _options$busy;

  return _objectSpread2(_objectSpread2({}, options), {}, {
    type: buildOptionValueOrFail({
      component: Component.FormSubmit,
      key: 'type',
      value: unref(options.type),
      alt: 'button'
    }),
    class: buildOptionValueOrFail({
      component: Component.FormSubmit,
      key: 'class',
      value: unref(options.class),
      alt: []
    }),
    validationRulesResult: unrefWithDefault(options.validationRulesResult, {}),
    updateText: buildOptionValueOrFail({
      component: Component.FormSubmit,
      key: 'updateText',
      value: unref(options.updateText),
      alt: 'Update'
    }),
    updateIconClass: buildOptionValueOrFail({
      component: Component.FormSubmit,
      key: 'updateIconClass',
      value: unref(options.updateIconClass),
      alt: [],
      library: _defineProperty({}, Library.FONT_AWESOME, {
        value: 'fa fa-save'
      })
    }),
    updateButtonClass: buildOptionValueOrFail({
      component: Component.FormSubmit,
      key: 'updateButtonClass',
      value: unref(options.updateButtonClass),
      alt: [],
      library: _defineProperty({}, Library.BOOTSTRAP, {
        value: 'btn btn-xs btn-primary'
      })
    }),
    createText: buildOptionValueOrFail({
      component: Component.FormSubmit,
      key: 'createText',
      value: unref(options.createText),
      alt: 'Create'
    }),
    createIconClass: buildOptionValueOrFail({
      component: Component.FormSubmit,
      key: 'createIconClass',
      value: unref(options.createIconClass),
      alt: [],
      library: _defineProperty({}, Library.FONT_AWESOME, {
        value: 'fa fa-plus'
      })
    }),
    createButtonClass: buildOptionValueOrFail({
      component: Component.FormSubmit,
      key: 'createButtonClass',
      value: unref(options.createButtonClass),
      alt: [],
      library: _defineProperty({}, Library.BOOTSTRAP, {
        value: 'btn btn-xs btn-success'
      })
    }),
    busy: (_options$busy = options.busy) !== null && _options$busy !== void 0 ? _options$busy : false,
    isEditing: unrefWithDefault(options.isEditing, false)
  });
}
function buildFormSubmit(input) {
  var options = buildFormSubmitOptions(input);
  return h('div', {
    class: 'form-group'
  }, [h(options.type, _objectSpread2(_objectSpread2({}, options.type === 'button' ? {
    type: 'submit'
  } : {}), {}, {
    class: [].concat(_toConsumableArray(options.isEditing ? [options.updateButtonClass] : []), _toConsumableArray(!options.isEditing ? [options.createButtonClass] : [])),
    disabled: options.validationRulesResult.$invalid || unref(options.busy),
    onClick: function onClick($event) {
      $event.preventDefault();
      setMaybeRefValue(options.busy, true);
      var promise = options.submit.apply(null);

      if (isPromise(promise)) {
        promise.then(function () {
          return setMaybeRefValue(options.busy, false);
        }).catch(function (e) {
          setMaybeRefValue(options.busy, false);
          throw e;
        });
      }

      return promise;
    }
  }), [h('i', {
    class: [].concat(_toConsumableArray(options.isEditing ? [options.updateIconClass] : []), _toConsumableArray(!options.isEditing ? [options.createIconClass] : []))
  }), ' ', options.isEditing ? options.updateText : options.createText])]);
}

function buildFormTextareaOptions(input) {
  var options = buildFormBaseOptions(input, Component.FormTextarea);
  return _objectSpread2({}, options);
}
function buildFormTextarea(input) {
  var options = buildFormTextareaOptions(input);
  var children = [];

  if (options.label) {
    children.push(h('label', [options.labelContent]));
  }

  var rawValue = unref(options.value);
  var rawValidationValue = unref(options.validationRulesResult.$model);
  return h(FormGroup, {
    validations: options.validationRulesResult,
    validationMessages: options.validationMessages,
    validationTranslator: options.validationTranslator
  }, {
    default: function _default() {
      return [].concat(children, [h('textarea', mergeProps(_objectSpread2(_objectSpread2({
        placeholder: '...',
        class: options.class,
        onInput: function onInput($event) {
          if ($event.target.composing) {
            return;
          }

          handleFormValueChanged(options, $event.target.value);
        }
      }, typeof rawValue !== 'undefined' ? {
        value: rawValue
      } : {}), typeof rawValidationValue !== 'undefined' ? {
        value: rawValidationValue
      } : {}), options.props))]);
    }
  });
}

function buildItemActionToggleOptions(options) {
  return _objectSpread2(_objectSpread2({}, options), {}, {
    type: buildOptionValueOrFail({
      component: Component.ItemActionToggle,
      key: 'type',
      value: unref(options.type),
      alt: 'button'
    }),
    class: buildOptionValueOrFail({
      component: Component.ItemActionToggle,
      key: 'class',
      value: unref(options.class),
      alt: []
    }),
    disabledClass: buildOptionValueOrFail({
      component: Component.ItemActionToggle,
      key: 'disabledClass',
      value: unref(options.disabledClass),
      alt: [],
      library: _defineProperty({}, Library.BOOTSTRAP, {
        value: 'btn-dark'
      })
    }),
    enabledClass: buildOptionValueOrFail({
      component: Component.ItemActionToggle,
      key: 'enabledClass',
      value: unref(options.enabledClass),
      alt: [],
      library: _defineProperty({}, Library.BOOTSTRAP, {
        value: 'btn-warning'
      })
    }),
    childType: buildOptionValueOrFail({
      component: Component.ItemActionToggle,
      key: 'childType',
      value: unref(options.childType),
      alt: 'i'
    }),
    childDisabledContent: buildOptionValueOrFail({
      component: Component.ItemActionToggle,
      key: 'childDisabledContent',
      value: unref(options.childDisabledContent),
      alt: []
    }),
    childDisabledClass: buildOptionValueOrFail({
      component: Component.ItemActionToggle,
      key: 'childDisabledClass',
      value: unref(options.childDisabledClass),
      alt: [],
      library: _defineProperty({}, Library.FONT_AWESOME, {
        value: 'fa fa-plus'
      })
    }),
    childEnabledContent: buildOptionValueOrFail({
      component: Component.ItemActionToggle,
      key: 'childEnabledContent',
      value: unref(options.childEnabledContent),
      alt: []
    }),
    childEnabledClass: buildOptionValueOrFail({
      component: Component.ItemActionToggle,
      key: 'childEnabledClass',
      value: unref(options.childEnabledClass),
      alt: [],
      library: _defineProperty({}, Library.FONT_AWESOME, {
        value: 'fa fa-minus'
      })
    }),
    busy: unrefWithDefault(options.busy, false)
  });
}
function buildItemActionToggle(input) {
  var options = buildItemActionToggleOptions(input);
  var busy = unrefWithDefault(options.busy, false);
  var value = unref(options.value);
  var currentValue = unref(options.currentValue);
  var child = h('');
  var childClass = value === currentValue ? options.childEnabledClass : options.childDisabledClass;
  var childContent = value === currentValue ? options.childEnabledContent : options.childDisabledContent;

  if (childClass || childContent) {
    child = h(options.childType, {
      class: childClass
    }, [childContent]);
  }

  return h(options.type, _objectSpread2(_objectSpread2({}, options.type === 'button' ? {
    type: 'button'
  } : {}), {}, {
    disabled: busy,
    class: [].concat(_toConsumableArray(options.class ? [options.class] : []), _toConsumableArray(options.disabledClass && value !== currentValue ? [options.disabledClass] : []), _toConsumableArray(options.enabledClass && value === currentValue ? [options.enabledClass] : [])),
    onClick: function onClick($event) {
      $event.preventDefault();

      if (typeof options.toggle === 'function') {
        options.toggle(value);
      }

      if (Array.isArray(currentValue)) {
        var index = currentValue.indexOf(value);

        if (index === -1) {
          pushMaybeRefArrayValue(options.currentValue, value);
        } else {
          spliceMaybeRefArray(options.currentValue, index, 1);
        }

        return;
      }

      if (value === currentValue) {
        setMaybeRefValue(options.currentValue, null);
        return;
      }

      setMaybeRefValue(options.currentValue, value);
    }
  }), [child]);
}

function buildListActionRefreshOptions(input) {
  var _options$busy;

  var options = buildListBaseOptions(input, Component.ListActionRefresh, {
    type: {
      alt: 'button'
    },
    class: {
      library: _defineProperty({}, Library.BOOTSTRAP, {
        value: 'btn btn-xs btn-dark'
      })
    }
  });
  return _objectSpread2(_objectSpread2({}, options), {}, {
    load: unrefWithDefault(options.load, function () {
      return Promise.resolve();
    }),
    busy: (_options$busy = options.busy) !== null && _options$busy !== void 0 ? _options$busy : false,
    text: buildOptionValueOrFail({
      component: Component.ListActionRefresh,
      key: 'text',
      value: unref(options.text),
      alt: true
    }),
    textContent: buildOptionValueOrFail({
      component: Component.ListActionRefresh,
      key: 'textContent',
      value: unref(options.textContent),
      alt: 'refresh'
    }),
    icon: buildOptionValueOrFail({
      component: Component.ListActionRefresh,
      key: 'icon',
      value: unref(options.icon),
      alt: true
    }),
    iconClass: buildOptionValueOrFail({
      component: Component.ListActionRefresh,
      key: 'iconClass',
      value: unref(options.iconClass),
      alt: [],
      library: _defineProperty({}, Library.FONT_AWESOME, {
        value: 'fa fa-refresh'
      })
    }),
    iconContent: buildOptionValueOrFail({
      component: Component.ListActionRefresh,
      key: 'iconContent',
      value: unref(options.iconContent),
      alt: []
    }),
    iconProps: unrefWithDefault(options.iconProps, {})
  });
}
function buildListActionRefresh(input) {
  var options = buildListActionRefreshOptions(input);
  var refreshActionChildren = [];

  if (options.icon) {
    refreshActionChildren.push(h('i', mergeProps({
      class: options.iconClass
    }, options.iconProps), [options.iconContent]));
  }

  if (options.text) {
    if (options.icon && typeof options.textContent === 'string') {
      refreshActionChildren.push(' ');
    }

    refreshActionChildren.push(options.textContent);
  }

  return h(options.type, mergeProps(_objectSpread2(_objectSpread2({}, options.type === 'button' ? {
    type: options.type
  } : {}), {}, {
    disabled: unref(options.busy),
    onClick: function onClick($event) {
      $event.preventDefault();
      setMaybeRefValue(options.busy, true);
      var promise = options.load.apply(null);

      if (isPromise(promise)) {
        promise.then(function () {
          return setMaybeRefValue(options.busy, false);
        }).catch(function (e) {
          setMaybeRefValue(options.busy, false);
          throw e;
        });
      }

      return promise;
    },
    class: options.class
  }), options.props), refreshActionChildren);
}

/*
 * Copyright (c) 2022.
 * Author Peter Placzek (tada5hi)
 * For the full copyright and license information,
 * view the LICENSE file that was distributed with this source code.
 */
var SlotName;

(function (SlotName) {
  SlotName["HEADER"] = "header";
  SlotName["HEADER_TITLE"] = "header-title";
  SlotName["HEADER_ACTIONS"] = "header-actions";
  SlotName["ITEMS"] = "items";
  SlotName["ITEMS_NO_MORE"] = "no-more";
  SlotName["ITEM"] = "item";
  SlotName["ITEM_ACTIONS"] = "item-actions";
  SlotName["ITEM_ACTIONS_EXTRA"] = "item-actions-extra";
  SlotName["DEFAULT"] = "default";
})(SlotName || (SlotName = {}));

function buildListTitleOptions(input) {
  var options = buildListBaseOptions(input, Component.ListTitle, {
    class: {
      alt: []
    }
  });
  return _objectSpread2(_objectSpread2({}, options), {}, {
    text: buildOptionValueOrFail({
      component: Component.ListTitle,
      key: 'text',
      value: unref(options.text),
      alt: true
    }),
    textClass: buildOptionValueOrFail({
      component: Component.ListTitle,
      key: 'textClass',
      value: unref(options.textClass),
      alt: [],
      library: _defineProperty({}, Library.BOOTSTRAP, {
        value: 'mb-0'
      })
    }),
    textType: buildOptionValueOrFail({
      component: Component.ListTitle,
      key: 'textType',
      value: unref(options.textType),
      alt: 'h4'
    }),
    textProps: buildOptionValueOrFail({
      component: Component.ListTitle,
      key: 'textProps',
      value: unref(options.textProps),
      alt: {}
    }),
    textContent: buildOptionValueOrFail({
      component: Component.ListTitle,
      key: 'textContent',
      value: unref(options.textContent),
      alt: 'List'
    }),
    icon: buildOptionValueOrFail({
      component: Component.ListTitle,
      key: 'icon',
      value: unref(options.icon),
      alt: true
    }),
    iconClass: buildOptionValueOrFail({
      component: Component.ListTitle,
      key: 'iconClass',
      value: unref(options.iconClass),
      alt: [],
      library: _defineProperty({}, Library.FONT_AWESOME, {
        value: 'fa fa-bars'
      })
    }),
    iconProps: buildOptionValueOrFail({
      component: Component.ListTitle,
      key: 'iconProps',
      value: unref(options.iconProps),
      alt: {}
    })
  });
}
function buildListTitle(input) {
  var options = buildListTitleOptions(input);

  if (hasNormalizedSlot(SlotName.HEADER_TITLE, options.slotItems)) {
    return normalizeSlot(SlotName.HEADER_TITLE, options.slotItems);
  }

  var children = [];

  if (options.icon) {
    children.push(h('i', mergeProps({
      class: options.iconClass
    }, options.iconProps)));
  }

  if (options.text) {
    if (options.icon && typeof options.textContent === 'string') {
      children.push(' ');
    }

    children = [h(options.textType, mergeProps({
      class: options.textClass
    }, options.textProps), [].concat(_toConsumableArray(children), [options.textContent]))];
  }

  return h(options.type, mergeProps({
    class: options.class
  }, options.props), children);
}

function buildListHeaderOptions(input) {
  var _options$load, _options$busy;

  var options = buildListBaseOptions(input, Component.ListHeader, {
    class: {
      alt: 'list-header',
      library: _defineProperty({}, Library.BOOTSTRAP, {
        value: 'd-flex flex-row mb-2 align-items-center'
      })
    }
  });
  return _objectSpread2(_objectSpread2({}, options), {}, {
    actionType: buildOptionValueOrFail({
      component: Component.ListHeader,
      key: 'actionType',
      value: unref(options.actionType),
      alt: 'div'
    }),
    actionClass: buildOptionValueOrFail({
      component: Component.ListHeader,
      key: 'actionClass',
      value: unref(options.actionClass),
      alt: [],
      library: _defineProperty({}, Library.BOOTSTRAP, {
        value: 'd-flex flex-row ml-auto'
      })
    }),
    actionProps: unrefWithDefault(options.actionProps, {}),
    actionRefresh: buildOptionValueOrFail({
      component: Component.ListHeader,
      key: 'actionRefresh',
      value: unref(options.actionRefresh),
      alt: true
    }),
    title: buildOptionValueOrFail({
      component: Component.ListHeader,
      key: 'title',
      value: unref(options.title),
      alt: true
    }),
    load: (_options$load = options.load) !== null && _options$load !== void 0 ? _options$load : function () {
      return Promise.resolve();
    },
    busy: (_options$busy = options.busy) !== null && _options$busy !== void 0 ? _options$busy : false
  });
}
function buildListHeader(input) {
  input = input || {};
  var options = buildListHeaderOptions(input);
  var slotScope = {
    busy: options.busy,
    load: options.load
  };

  if (hasNormalizedSlot(SlotName.HEADER, options.slotItems)) {
    return normalizeSlot(SlotName.HEADER, slotScope, options.slotItems);
  }

  var headerChildren = [];

  if (options.title) {
    if (typeof options.title === 'boolean') {
      options.title = {};
    }

    headerChildren.push(buildListTitle(options.title));
  } // -------------------------------------------------------------


  if (hasNormalizedSlot(SlotName.HEADER_ACTIONS, options.slotItems)) {
    headerChildren.push(normalizeSlot(SlotName.HEADER_ACTIONS, {
      load: options.load,
      busy: options.busy
    }, options.slotItems));
  } else {
    var actions = [];

    if (options.actionRefresh) {
      actions.push(buildListActionRefresh(_objectSpread2({
        load: options.load,
        busy: options.busy
      }, typeof options.actionRefresh === 'boolean' ? {} : options.actionRefresh)));
    }

    if (actions.length > 0) {
      headerChildren.push(h(options.actionType, mergeProps({
        class: options.actionClass
      }, options.actionProps), actions));
    }
  } // -------------------------------------------------------------


  return h(options.type, mergeProps({
    class: options.class
  }, options.props), headerChildren);
}

function buildListItemOptions(input) {
  var _library2;

  var options = buildListBaseOptions(input, Component.ListItem, {
    class: {
      alt: 'list-item',
      library: _defineProperty({}, Library.BOOTSTRAP, {
        value: 'd-flex flex-row align-items-center'
      })
    }
  });
  return _objectSpread2(_objectSpread2({}, options), {}, {
    icon: buildOptionValueOrFail({
      component: Component.ListItem,
      key: 'icon',
      value: unref(options.icon),
      alt: true
    }),
    iconClass: buildOptionValueOrFail({
      component: Component.ListItem,
      key: 'iconClass',
      value: unref(options.iconClass),
      alt: [],
      library: (_library2 = {}, _defineProperty(_library2, Library.BOOTSTRAP, {
        value: 'pr-1'
      }), _defineProperty(_library2, Library.FONT_AWESOME, {
        value: 'fa fa-bars'
      }), _library2)
    }),
    iconProps: unrefWithDefault(options.iconProps, {}),
    textPropName: buildOptionValueOrFail({
      component: Component.ListItem,
      key: 'textPropName',
      value: unref(options.textPropName),
      alt: 'name'
    }),
    index: unref(options.index),
    key: unref(options.key),
    data: unref(options.data),
    actions: buildOptionValueOrFail({
      component: Component.ListItem,
      key: 'actions',
      value: unref(options.actions),
      alt: []
    }),
    busy: unrefWithDefault(options.busy, false)
  });
}
function buildListItem(input) {
  var options = buildListItemOptions(input);

  var slotProps = _objectSpread2({
    itemBusy: options.busy,
    item: options.data,
    busy: options.busy,
    index: options.index
  }, options.slotProps || {});

  if (hasNormalizedSlot(SlotName.ITEM, options.slotItems)) {
    return normalizeSlot(SlotName.ITEM, slotProps, options.slotItems);
  } // todo: maybe wrap item :)


  if (typeof options.fn === 'function') {
    return options.fn(options.data, options.index);
  }

  var children = [];

  if (options.icon) {
    // class: pr-1
    children.push(h('div', [h('i', mergeProps({
      class: options.iconClass
    }, options.iconProps))]));
  }

  var itemText;

  if (options.textFn) {
    itemText = options.textFn(options.data);
  } else if (hasOwnProperty(options.data, options.textPropName)) {
    itemText = options.data[options.textPropName];
  }

  if (itemText) {
    children.push(itemText);
  }

  var actions = [];

  if (hasNormalizedSlot(SlotName.ITEM_ACTIONS, options.slotItems)) {
    actions = [normalizeSlot(SlotName.ITEM_ACTIONS, slotProps, options.slotItems)];
  } else if (options.actions) {
    actions = _toConsumableArray(Array.isArray(options.actions) ? options.actions : [options.actions]);

    if (hasNormalizedSlot(SlotName.ITEM_ACTIONS_EXTRA, options.slotItems)) {
      actions.push(normalizeSlot(SlotName.ITEM_ACTIONS_EXTRA, slotProps, options.slotItems));
    }
  }

  if (actions && actions.length > 0) {
    children.push(h('div', {
      class: 'ml-auto'
    }, actions));
  }

  return h(options.type, mergeProps({
    key: options.index
  }, {
    class: options.class
  }, options.props), children);
}

function buildListItemsOptions(input) {
  var options = buildListBaseOptions(input, Component.ListItems, {
    class: {
      alt: 'list-items'
    }
  });
  return _objectSpread2(_objectSpread2({}, options), {}, {
    busy: unrefWithDefault(options.busy, false),
    items: unrefWithDefault(options.items, []),
    item: unrefWithDefault(options.item, {})
  });
}
function buildListItems(input) {
  input = input || {};
  var options = buildListItemsOptions(input);

  if (hasNormalizedSlot(SlotName.ITEMS, options.slotItems)) {
    return normalizeSlot(SlotName.ITEMS, _objectSpread2(_objectSpread2({}, options.slotProps), {}, {
      items: options.items,
      busy: options.busy
    }), options.slotItems);
  } // ----------------------------------------------------------------------


  return h(options.type, mergeProps({
    class: options.class
  }, options.props), options.items.map(function (item, index) {
    return buildListItem(_objectSpread2(_objectSpread2(_objectSpread2({}, options.slotProps), options.item), {}, {
      data: item,
      index: index
    }));
  }));
}

function buildListNoMoreOptions(input) {
  var options = buildListBaseOptions(input, Component.ListNoMore, {
    class: {
      alt: 'list-no-more',
      library: _defineProperty({}, Library.BOOTSTRAP, {
        value: 'alert alert-warning alert-sm'
      })
    }
  });
  return _objectSpread2(_objectSpread2({}, options), {}, {
    textContent: buildOptionValueOrFail({
      component: Component.ListNoMore,
      key: 'textContent',
      value: unref(options.textContent),
      alt: 'No more items available...'
    }),
    busy: unrefWithDefault(options.busy, false),
    total: unrefWithDefault(options.total, 0)
  });
}
function buildListNoMore(input) {
  input = input || {};
  var options = buildListNoMoreOptions(input);

  if (options.busy || options.total > 0) {
    return h('');
  }

  if (hasNormalizedSlot(SlotName.ITEMS_NO_MORE, options.slotItems)) {
    return normalizeSlot(SlotName.ITEMS_NO_MORE, _objectSpread2(_objectSpread2({}, options.slotProps), {}, {
      busy: options.busy,
      total: options.total
    }), options.slotItems);
  }

  return h(options.type, mergeProps({
    class: options.class
  }, options.props), [options.textContent]);
}

var Pagination = defineComponent({
  props: {
    total: {
      type: Number,
      default: 0
    },
    limit: {
      type: Number,
      default: 0
    },
    offset: {
      type: Number,
      default: 0
    },
    busy: {
      type: Boolean,
      default: false
    }
  },
  emits: ['load'],
  setup: function setup(props, _ref) {
    var emit = _ref.emit;
    var totalPages = computed(function () {
      if (props.limit === 0 || props.total === 0) return 1;
      var pages = Math.ceil(props.total / props.limit);
      return pages >= 1 ? pages : 1;
    });
    var currentPage = computed(function () {
      if (props.limit === 0 || props.total === 0) return 1;
      return Math.floor(props.offset / props.limit) + 1;
    });
    var pages = computed(function () {
      var items = [];

      for (var i = currentPage.value - 2; i < currentPage.value + 2; i++) {
        if (i > 0 && i <= totalPages.value) {
          items.push(i);
        }
      }

      return items;
    });

    var goTo = function goTo(page) {
      if (props.busy || page === currentPage.value) return;
      var data = {
        page: page,
        offset: (page - 1) * props.limit,
        limit: props.limit,
        total: totalPages.value
      };
      emit('load', data);
    };

    var renderPrevPage = function renderPrevPage() {
      var content;
      var prevClass = buildOptionValue({
        component: Component.Pagination,
        key: 'prevClass',
        alt: [],
        library: _defineProperty({}, Library.FONT_AWESOME, {
          value: 'fa fa-chevron-left'
        })
      });
      var prevContent = buildOptionValue({
        component: Component.Pagination,
        key: 'prevContent'
      });

      if (prevClass || prevContent) {
        content = h(buildOptionValueOrFail({
          component: Component.Pagination,
          key: 'prevType',
          alt: 'i'
        }), {
          class: prevClass
        }, prevContent);
      } else {
        content = [currentPage.value - 1];
      }

      var prevPage = h('');

      if (currentPage.value > 1) {
        prevPage = h('li', {
          class: buildOptionValueOrFail({
            component: Component.Pagination,
            key: 'itemClass',
            alt: 'page-item'
          })
        }, [h('button', {
          class: buildOptionValueOrFail({
            component: Component.Pagination,
            key: 'linkClass',
            alt: 'page-link'
          }),
          disabled: props.busy,
          onClick: function onClick($event) {
            $event.preventDefault();
            return goTo(currentPage.value - 1);
          }
        }, [content])]);
      }

      return prevPage;
    };

    var renderBetweenPages = function renderBetweenPages() {
      var betweenPages = [];

      var _loop = function _loop(i) {
        var node = h('li', {
          class: buildOptionValueOrFail({
            component: Component.Pagination,
            key: 'itemClass',
            alt: 'page-item'
          })
        }, [h('button', _objectSpread2(_objectSpread2({}, mergeProps(_objectSpread2({}, pages.value[i] === currentPage.value ? {
          class: buildOptionValueOrFail({
            component: Component.Pagination,
            key: 'linkActiveClass',
            alt: 'active'
          })
        } : {}), {
          class: buildOptionValueOrFail({
            component: Component.Pagination,
            key: 'linkClass',
            alt: 'page-link'
          })
        })), {}, {
          disabled: props.busy,
          onClick: function onClick($event) {
            $event.preventDefault(); // eslint-disable-next-line prefer-rest-params

            return goTo(pages.value[i]);
          }
        }), [pages.value[i]])]);
        betweenPages.push(node);
      };

      for (var i = 0; i < pages.value.length; i++) {
        _loop(i);
      }

      return betweenPages;
    };

    var renderNextPage = function renderNextPage() {
      var nextPage = h('');
      var content;
      var nextClass = buildOptionValue({
        component: Component.Pagination,
        key: 'nextClass',
        alt: [],
        library: _defineProperty({}, Library.FONT_AWESOME, {
          value: 'fa fa-chevron-right'
        })
      });
      var nextContent = buildOptionValue({
        component: Component.Pagination,
        key: 'nextContent'
      });

      if (nextClass || nextContent) {
        content = h(buildOptionValueOrFail({
          component: Component.Pagination,
          key: 'nextType',
          alt: 'i'
        }), {
          class: nextClass
        }, nextContent);
      } else {
        content = [currentPage.value + 1];
      }

      if (currentPage.value < totalPages.value) {
        nextPage = h('li', {
          class: buildOptionValueOrFail({
            component: Component.Pagination,
            key: 'itemClass',
            alt: 'page-item'
          })
        }, [h('button', {
          class: buildOptionValueOrFail({
            component: Component.Pagination,
            key: 'linkClass',
            alt: 'page-link'
          }),
          disabled: props.busy,
          onClick: function onClick($event) {
            $event.preventDefault();
            return goTo(currentPage.value + 1);
          }
        }, [content])]);
      }

      return nextPage;
    };

    return function () {
      return h('ul', {
        class: buildOptionValueOrFail({
          component: Component.Pagination,
          key: 'class',
          alt: 'pagination',
          library: _defineProperty({}, Library.BOOTSTRAP, {
            value: 'justify-content-center'
          })
        })
      }, [renderPrevPage(), renderBetweenPages(), renderNextPage()]);
    };
  }
});

function buildListPaginationOptions(input) {
  var options = buildListBaseOptions(input, Component.ListPagination, {
    class: {
      alt: 'list-pagination'
    }
  });
  return _objectSpread2(_objectSpread2({}, options), {}, {
    busy: unrefWithDefault(options.busy, false),
    meta: unrefWithDefault(options.meta, {})
  });
}
function buildListPagination(input) {
  input = input || {};
  var options = buildListPaginationOptions(input);
  return h(options.type, mergeProps({
    class: options.class
  }, options.props), [h(Pagination, _objectSpread2(_objectSpread2(_objectSpread2({}, options.meta), {}, {
    busy: options.busy
  }, options.load ? {
    onLoad: options.load
  } : {}), options.props))]);
}

function buildListSearchOptions(input) {
  var options = buildListBaseOptions(input, Component.ListSearch, {
    class: {
      alt: 'list-search'
    }
  });
  return _objectSpread2({}, options);
}
function buildListSearch(input) {
  input = input || {};
  var options = buildListSearchOptions(input);
  return h(options.type, mergeProps({
    class: options.class
  }, options.props), [buildFormInput({
    value: options.value,
    change: options.change,
    label: false,
    groupPrepend: true,
    groupPrependTextContent: h('i', {
      class: 'fa fa-search'
    })
  })]);
}

var install = function install(instance, options) {
  if (_typeof(options) === 'object') {
    setConfig(options);
  }

  Object.entries(components).forEach(function (_ref) {
    var _ref2 = _slicedToArray(_ref, 2),
        componentName = _ref2[0],
        component = _ref2[1];

    instance.component(componentName, component);
  });
}; // Create module definition for Vue.use()

export { Component, FormGroup, Library, Pagination, SlotName, buildFormBaseOptions, buildFormInput, buildFormInputOptions, buildFormSelect, buildFormSelectOptions, buildFormSubmit, buildFormSubmitOptions, buildFormTextarea, buildFormTextareaOptions, buildItemActionToggle, buildItemActionToggleOptions, buildListActionRefresh, buildListActionRefreshOptions, buildListBaseOptions, buildListHeader, buildListHeaderOptions, buildListItem, buildListItemOptions, buildListItems, buildListItemsOptions, buildListNoMore, buildListNoMoreOptions, buildListPagination, buildListPaginationOptions, buildListSearch, buildListSearchOptions, buildListTitle, buildListTitleOptions, buildOptionValue, buildOptionValueOrFail, install as default, extendConfig, extendOptionValueWithLibraries, getConfigComponentOption, getConfigLibraryComponentOption, handleFormValueChanged, hasConfigComponentOption, hasConfigLibraryComponentOption, hasNormalizedSlot, hasOwnProperty, initPropertiesFromSource, isPromise, isVNodeClassOption, isVNodeListenerOption, isVNodeOption, isVNodePropsOption, isVNodeStyleOption, mergeOption, mergeOptions, mergeVNodeOption, normalizeSlot, pushMaybeRefArrayValue, setConfig, setMaybeRefValue, spliceMaybeRefArray, unrefWithDefault, unrefWithOptionalDefault, useConfig };
