import { Slots, VNode, VNodeChild } from 'vue';
import { MaybeRef, ToMaybeRef, VNodeClass, VNodeProperties } from '../type';
import { PaginationMeta } from './pagination';
export declare type ValidationResultRules<T = unknown> = {
    $model: T;
    readonly $dirty: boolean;
    readonly $error: boolean;
    readonly $invalid: boolean;
    readonly $anyDirty: boolean;
    readonly $pending: boolean;
    readonly $path: string;
    [key: string]: any;
};
export declare type ValidationTranslator = (input: string, parameters: Record<string, any>) => string | undefined;
export declare type ValidationMessages = Record<string, string>;
export declare type OptionsInput<T, R extends keyof T = never, P extends keyof T = never, MR extends keyof T = never> = Pick<T, R> & Partial<Pick<T, P>> & ToMaybeRef<Pick<T, MR>> & Partial<ToMaybeRef<Pick<T, Exclude<keyof T, R | P | MR>>>>;
export declare type ListLoadFn = (data?: PaginationMeta) => Promise<void> | void;
export declare type ListBaseOptions = {
    slotItems: Slots;
    slotProps: Record<string, any>;
    type: string;
    class: VNodeClass;
    props: VNodeProperties;
};
export declare type ListBaseOptionsInput = OptionsInput<ListBaseOptions, never, 'slotItems'>;
export declare type ExpectListBaseOptions<T extends ListBaseOptions | ListBaseOptionsInput> = Omit<T, keyof ListBaseOptions | keyof ListBaseOptionsInput>;
export declare type FormBaseOptions = {
    label: boolean;
    labelContent: string | VNode | (VNode | string)[] | VNodeChild;
    class: VNodeClass;
    props: VNodeProperties;
    value?: MaybeRef<unknown>;
    change?: (input: any) => void;
    validationRulesResult: Partial<ValidationResultRules>;
    validationMessages: ValidationMessages;
    validationTranslator?: ValidationTranslator;
};
export declare type FormBaseOptionsInput = OptionsInput<FormBaseOptions, never, 'value' | 'change' | 'validationTranslator'>;
export declare type ExpectFormBaseOptions<T extends FormBaseOptions | FormBaseOptionsInput> = Omit<T, keyof FormBaseOptions | keyof FormBaseOptionsInput>;
//# sourceMappingURL=type.d.ts.map