import { Slots, VNode } from 'vue';
/**
 * Returns true if either scoped or unscoped named slot exists
 *
 * @returns {Array|undefined} VNodes
 *
 * @param names
 * @param $slots
 */
export declare function hasNormalizedSlot(names: string[] | string, $slots?: Slots): boolean;
/**
 * Returns VNodes for named slot either scoped or unscoped
 *
 * @param names
 * @param {String} scope
 * @param $slots
 *
 * @returns {Array} VNodes
 */
export declare function normalizeSlot(names: string[] | string, scope?: Record<string, any>, $slots?: Slots): VNode[] | VNode;
//# sourceMappingURL=normalize-slot.d.ts.map