import { Ref, VNodeProps } from 'vue';
import { Component, ComponentOptions } from './options';
export declare type NonBoolean<T> = T extends boolean ? never : T;
export declare type MaybeRef<T> = T | Ref<T>;
export declare type ToMaybeRef<T> = {
    [K in keyof T]: MaybeRef<T[K]>;
};
export declare type VNodeClass = string | string[] | Record<string, boolean> | VNodeClass[];
export declare type VNodeProperties = VNodeProps & {
    class?: VNodeClass;
    [key: string]: any;
};
export declare type LibraryConfigOptions = {
    [K in `${Component}` | Component]?: Partial<ComponentOptions<K>>;
};
export declare type LibraryConfig = {
    enabled: boolean;
    options?: LibraryConfigOptions;
};
//# sourceMappingURL=type.d.ts.map